#include <bits/stdc++.h>
#define pii pair<int,int>
#define x first
#define y second
using namespace std;

vector<pii> v;
int redom[100007];
int fen[100007];
int get(int idx)
{
    int res=0;
    while(idx)
    {
        res+=fen[idx];
        idx-=idx&-idx;
    }
    return res;
}
void update(int idx, int val)
{
    while(idx<=100006)
    {
        fen[idx]+=val;
        idx+=idx&-idx;
    }
}

long long Resi(int N, int *A, int *B)
{
    for(int i=0;i<N;i++) v.push_back({A[i],i});
    sort(v.begin(),v.end());
    for(int i=0;i<v.size();i++) redom[i]=v[i].y;
    long long res=0;
    int sad=0;
    update(B[redom[0]],1);
    for(int i=1;i<v.size();i++)
    {
        int brm=0;
        //for(int j=0;j<i;j++) brv+=(B[redom[j]]>B[redom[i]]);
        brm=get(B[redom[i]]);
        res+=min(1LL*brm,1LL*(i-1-brm));
        update(B[redom[i]],1);
    }
    return res;
}